CREATE TABLE IF NOT EXISTS public.sexo
(
    idsexo integer NOT NULL,
    nombre character varying COLLATE pg_catalog."default" NOT NULL,
    CONSTRAINT sexo_pkey PRIMARY KEY (idsexo)
)

TABLESPACE pg_default;

insert into public.sexo values(1, 'Femenino');
insert into public.sexo values(2, 'Masculino');

CREATE TABLE IF NOT EXISTS public.tipodocumento
(
    idtipodocumento integer NOT NULL,
    nombre character varying(50) COLLATE pg_catalog."default",
    CONSTRAINT tipodocumento_pkey PRIMARY KEY (idtipodocumento)
)

TABLESPACE pg_default;

insert into public.tipodocumento values(1, 'Cédula de Ciudadanía');
insert into public.tipodocumento values(2, 'Cédula de Extranjería');
insert into public.tipodocumento values(3, 'Registro Civil');
insert into public.tipodocumento values(4, 'Tarjeta de Identidad');

CREATE TABLE IF NOT EXISTS public.departamento
(
    iddepartamento integer NOT NULL,
    codigo character varying(4) COLLATE pg_catalog."default" NOT NULL,
    nombre character varying(100) COLLATE pg_catalog."default" NOT NULL,
    CONSTRAINT departamento_pkey PRIMARY KEY (iddepartamento)
)

TABLESPACE pg_default;

insert into public.departamento values (1, '05',	'ANTIOQUIA');


CREATE TABLE IF NOT EXISTS public.ciudad
(
    idciudad integer NOT NULL,
    nombre character varying(100) COLLATE pg_catalog."default" NOT NULL,
    codigo character varying(10) COLLATE pg_catalog."default" NOT NULL,
    iddepartamento integer NOT NULL,
    CONSTRAINT ciudad_pkey PRIMARY KEY (idciudad),
    CONSTRAINT ciudad_iddepartamento_fkey FOREIGN KEY (iddepartamento)
        REFERENCES public.departamento (iddepartamento) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
)

TABLESPACE pg_default;

insert into ciudad values(1,'MEDELLIN','5001',1);
insert into ciudad values(2,'ABEJORRAL','5002',1);
insert into ciudad values(3,'ABRIAQUI','5004',1);
insert into ciudad values(4,'ALEJANDRIA','5021',1);
insert into ciudad values(5,'AMAGA','5030',1);
insert into ciudad values(6,'AMALFI','5031',1);
insert into ciudad values(7,'ANDES','5034',1);
insert into ciudad values(8,'ANGELOPOLIS','5036',1);
insert into ciudad values(9,'ANGOSTURA','5038',1);
insert into ciudad values(10,'ANORI','5040',1);
insert into ciudad values(11,'SANTAFE DE ANTIOQUIA','5042',1);
insert into ciudad values(12,'ANZA','5044',1);
insert into ciudad values(13,'APARTADO','5045',1);
insert into ciudad values(14,'ARBOLETES','5051',1);
insert into ciudad values(15,'ARGELIA','5055',1);
insert into ciudad values(16,'ARMENIA','5059',1);
insert into ciudad values(17,'BARBOSA','5079',1);
insert into ciudad values(18,'BELMIRA','5086',1);
insert into ciudad values(19,'BELLO','5088',1);
insert into ciudad values(20,'BETANIA','5091',1);
insert into ciudad values(21,'BETULIA','5093',1);
insert into ciudad values(22,'CIUDAD BOLIVAR','5101',1);
insert into ciudad values(23,'BRICEÑO','5107',1);
insert into ciudad values(24,'BURITICA','5113',1);
insert into ciudad values(25,'CACERES','5120',1);
insert into ciudad values(26,'CAICEDO','5125',1);
insert into ciudad values(27,'CALDAS','5129',1);
insert into ciudad values(28,'CAMPAMENTO','5134',1);
insert into ciudad values(29,'CAÑASGORDAS','5138',1);
insert into ciudad values(30,'CARACOLI','5142',1);
insert into ciudad values(31,'CARAMANTA','5145',1);
insert into ciudad values(32,'CAREPA','5147',1);
insert into ciudad values(33,'EL CARMEN DE VIBORAL','5148',1);
insert into ciudad values(34,'CAROLINA','5150',1);
insert into ciudad values(35,'CAUCASIA','5154',1);
insert into ciudad values(36,'CHIGORODO','5172',1);
insert into ciudad values(37,'CISNEROS','5190',1);
insert into ciudad values(38,'COCORNA','5197',1);
insert into ciudad values(39,'CONCEPCION','5206',1);
insert into ciudad values(40,'CONCORDIA','5209',1);
insert into ciudad values(41,'COPACABANA','5212',1);
insert into ciudad values(42,'DABEIBA','5234',1);
insert into ciudad values(43,'DON MATIAS','5237',1);
insert into ciudad values(44,'EBEJICO','5240',1);
insert into ciudad values(45,'EL BAGRE','5250',1);
insert into ciudad values(46,'ENTRERRIOS','5264',1);
insert into ciudad values(47,'ENVIGADO','5266',1);
insert into ciudad values(48,'FREDONIA','5282',1);
insert into ciudad values(49,'FRONTINO','5284',1);
insert into ciudad values(50,'GIRALDO','5306',1);
insert into ciudad values(51,'GIRARDOTA','5308',1);
insert into ciudad values(52,'GOMEZ PLATA','5310',1);
insert into ciudad values(53,'GRANADA','5313',1);
insert into ciudad values(54,'GUADALUPE','5315',1);
insert into ciudad values(55,'GUARNE','5318',1);
insert into ciudad values(56,'GUATAPE','5321',1);
insert into ciudad values(57,'HELICONIA','5347',1);
insert into ciudad values(58,'HISPANIA','5353',1);
insert into ciudad values(59,'ITAGUI','5360',1);
insert into ciudad values(60,'ITUANGO','5361',1);
insert into ciudad values(61,'JARDIN','5364',1);
insert into ciudad values(62,'JERICO','5368',1);
insert into ciudad values(63,'LA CEJA','5376',1);
insert into ciudad values(64,'LA ESTRELLA','5380',1);
insert into ciudad values(65,'LA PINTADA','5390',1);
insert into ciudad values(66,'LA UNION','5400',1);
insert into ciudad values(67,'LIBORINA','5411',1);
insert into ciudad values(68,'MACEO','5425',1);
insert into ciudad values(69,'MARINILLA','5440',1);
insert into ciudad values(70,'MONTEBELLO','5467',1);
insert into ciudad values(71,'MURINDO','5475',1);
insert into ciudad values(72,'MUTATA','5480',1);
insert into ciudad values(73,'NARIÑO','5483',1);
insert into ciudad values(74,'NECOCLI','5490',1);
insert into ciudad values(75,'NECHI','5495',1);
insert into ciudad values(76,'OLAYA','5501',1);
insert into ciudad values(77,'PEÑOL','5541',1);
insert into ciudad values(78,'PEQUE','5543',1);
insert into ciudad values(79,'PUEBLORRICO','5576',1);
insert into ciudad values(80,'PUERTO BERRIO','5579',1);
insert into ciudad values(81,'PUERTO NARE','5585',1);
insert into ciudad values(82,'PUERTO TRIUNFO','5591',1);
insert into ciudad values(83,'REMEDIOS','5604',1);
insert into ciudad values(84,'RETIRO','5607',1);
insert into ciudad values(85,'RIONEGRO','5615',1);
insert into ciudad values(86,'SABANALARGA','5628',1);
insert into ciudad values(87,'SABANETA','5631',1);
insert into ciudad values(88,'SALGAR','5642',1);
insert into ciudad values(89,'SAN ANDRES DE CUERQUIA','5647',1);
insert into ciudad values(90,'SAN CARLOS','5649',1);
insert into ciudad values(91,'SAN FRANCISCO','5652',1);
insert into ciudad values(92,'SAN JERONIMO','5656',1);
insert into ciudad values(93,'SAN JOSE DE LA MONTAÑA','5658',1);
insert into ciudad values(94,'SAN JUAN DE URABA','5659',1);
insert into ciudad values(95,'SAN LUIS','5660',1);
insert into ciudad values(96,'SAN PEDRO','5664',1);
insert into ciudad values(97,'SAN PEDRO DE URABA','5665',1);
insert into ciudad values(98,'SAN RAFAEL','5667',1);
insert into ciudad values(99,'SAN ROQUE','5670',1);
insert into ciudad values(100,'SAN VICENTE','5674',1);
insert into ciudad values(101,'SANTA BARBARA','5679',1);
insert into ciudad values(102,'SANTA ROSA DE OSOS','5686',1);
insert into ciudad values(103,'SANTO DOMINGO','5690',1);
insert into ciudad values(104,'EL SANTUARIO','5697',1);
insert into ciudad values(105,'SEGOVIA','5736',1);
insert into ciudad values(106,'SONSON','5756',1);
insert into ciudad values(107,'SOPETRAN','5761',1);
insert into ciudad values(108,'TAMESIS','5789',1);
insert into ciudad values(109,'TARAZA','5790',1);
insert into ciudad values(110,'TARSO','5792',1);
insert into ciudad values(111,'TITIRIBI','5809',1);
insert into ciudad values(112,'TOLEDO','5819',1);
insert into ciudad values(113,'TURBO','5837',1);
insert into ciudad values(114,'URAMITA','5842',1);
insert into ciudad values(115,'URRAO','5847',1);
insert into ciudad values(116,'VALDIVIA','5854',1);
insert into ciudad values(117,'VALPARAISO','5856',1);
insert into ciudad values(118,'VEGACHI','5858',1);
insert into ciudad values(119,'VENECIA','5861',1);
insert into ciudad values(120,'VIGIA DEL FUERTE','5873',1);
insert into ciudad values(121,'YALI','5885',1);
insert into ciudad values(122,'YARUMAL','5887',1);
insert into ciudad values(123,'YOLOMBO','5890',1);
insert into ciudad values(124,'YONDO','5893',1);
insert into ciudad values(125,'ZARAGOZA','5895',1);


CREATE TABLE IF NOT EXISTS public.usuario
(
    idusuario bigserial NOT NULL,
    idpersona bigint NOT NULL,
    nombreusuario character varying(200) COLLATE pg_catalog."default" NOT NULL,
    clave character varying(200) COLLATE pg_catalog."default" NOT NULL,
    activo boolean NOT NULL,
    fechaultimoingreso timestamp without time zone,
    fechaactualizacion timestamp without time zone,
    fechacreacion timestamp without time zone,
    idusuariocreacion bigint,
    idusuarioactualizacion bigint,
    CONSTRAINT usuario_pkey PRIMARY KEY (idusuario),
    CONSTRAINT usuario_ukey UNIQUE (nombreusuario),
    CONSTRAINT usuario_idusuarioactualizacion_fkey FOREIGN KEY (idusuarioactualizacion)
        REFERENCES public.usuario (idusuario) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT usuario_idusuariocreacion_fkey FOREIGN KEY (idusuariocreacion)
        REFERENCES public.usuario (idusuario) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
)

TABLESPACE pg_default;

CREATE TABLE IF NOT EXISTS public.persona
(
    idpersona bigserial NOT NULL,
    idtipodocumento integer NOT NULL,
    numerodocumento character varying(20) COLLATE pg_catalog."default" NOT NULL,
    primernombre character varying(100) COLLATE pg_catalog."default" NOT NULL,
    segundonombre character varying(100) COLLATE pg_catalog."default",
    primerapellido character varying(100) COLLATE pg_catalog."default" NOT NULL,
    segundoapellido character varying(100) COLLATE pg_catalog."default",
    idsexo integer NOT NULL,
    fechanacimiento timestamp without time zone NOT NULL,
    idciudad integer NOT NULL,
    direccion character varying(500) COLLATE pg_catalog."default" NOT NULL,
    celular character varying(200) COLLATE pg_catalog."default",
    correoelectronico character varying(200) COLLATE pg_catalog."default",
    fechacreacion timestamp without time zone NOT NULL,
	fechaactualizacion timestamp without time zone NOT NULL,
	idusuariocreacion bigint,
    idusuarioactualizacion bigint,
    CONSTRAINT persona_pkey PRIMARY KEY (idpersona),
    CONSTRAINT persona_numerodocumento_uq UNIQUE (numerodocumento, idtipodocumento),
    CONSTRAINT persona_idtipodocumento_fkey FOREIGN KEY (idtipodocumento)
        REFERENCES public.tipodocumento (idtipodocumento) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT persona_idciudad_fkey FOREIGN KEY (idciudad)
        REFERENCES public.ciudad (idciudad) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT persona_idsexo_fkey FOREIGN KEY (idsexo)
        REFERENCES public.sexo (idsexo) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT persona_idusuarioactualizacion_fkey FOREIGN KEY (idusuarioactualizacion)
        REFERENCES public.usuario (idusuario) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT persona_idusuariocreacion_fkey FOREIGN KEY (idusuariocreacion)
        REFERENCES public.usuario (idusuario) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
)

TABLESPACE pg_default;

alter table usuario add CONSTRAINT usuario_idpersona_fkey FOREIGN KEY (idpersona)
        REFERENCES public.persona (idpersona) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION;

insert into persona (idtipodocumento, numerodocumento, primernombre, segundonombre, primerapellido, segundoapellido, idsexo, fechanacimiento, idciudad, direccion, celular, correoelectronico, fechacreacion, fechaactualizacion)
values (1,	'1020429608',	'Cindy',	'Paola',	'Cardona',	'Henao', 1,	'1990-03-04 00:00:00',	19,	'Calle 47 # 45 - 26. Apto 202',	'3012187843',	'cpaola.cardona@udea.edu.co', now(), now());

insert into usuario (idpersona, nombreusuario, clave, activo, fechaactualizacion, fechacreacion)
values(	1,	'ccardona',	'a665a45920422f9d417e4867efdc4fb8a04a1f3fff1fa07e998e86f7f7a27ae3', true, now(), now());

CREATE TABLE IF NOT EXISTS public.rol
(
    idrol integer NOT NULL,
    nombre character varying COLLATE pg_catalog."default" NOT NULL,
    CONSTRAINT rol_pkey PRIMARY KEY (idrol)
)

TABLESPACE pg_default;		

insert into rol values (1,	'Administrador');
insert into rol values (2,	'Usuario');

CREATE TABLE IF NOT EXISTS public.usuariorol
(
    idusuario bigint NOT NULL,
    idrol integer NOT NULL,
    CONSTRAINT usuariorol_pkey PRIMARY KEY (idusuario, idrol),
    CONSTRAINT usuariorol_idrol_fkey FOREIGN KEY (idrol)
        REFERENCES public.rol (idrol) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT usuariorol_idusuario_fkey FOREIGN KEY (idusuario)
        REFERENCES public.usuario (idusuario) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
)

TABLESPACE pg_default;

insert into usuariorol values (1, 1);


CREATE TABLE IF NOT EXISTS public.estadoatencion
(
    idestado integer NOT NULL,
    nombre character varying COLLATE pg_catalog."default" NOT NULL,
    CONSTRAINT estadoatencion_pkey PRIMARY KEY (idestado)
)

TABLESPACE pg_default;


CREATE TABLE IF NOT EXISTS public.cuestionariopanas
(
    idcuestionario bigserial NOT NULL,
    idpersona bigint NOT NULL,
    idestado integer NOT NULL,
    fechacreacion timestamp without time zone NOT NULL,
    idusuariocreacion bigint,
    idusuarioactualizacion bigint,
    fechaactualizacion timestamp without time zone NOT NULL,
    CONSTRAINT cuestionariopanas_pkey PRIMARY KEY (idcuestionario),
    CONSTRAINT cuestionariopanas_idestado_fkey FOREIGN KEY (idestado)
        REFERENCES public.estadoatencion (idestado) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT cuestionariopanas_idpersona_fkey FOREIGN KEY (idpersona)
        REFERENCES public.persona (idpersona) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT cuestionariopanas_idusuarioactualizacion_fkey FOREIGN KEY (idusuarioactualizacion)
        REFERENCES public.usuario (idusuario) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT cuestionariopanas_idusuariocreacion_fkey FOREIGN KEY (idusuariocreacion)
        REFERENCES public.usuario (idusuario) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
)

TABLESPACE pg_default;		


insert into estadoatencion values(1,	'Creada');
insert into estadoatencion values(2,	'Gestionada');
insert into estadoatencion values(3,	'Terminada');



CREATE TABLE IF NOT EXISTS public.preguntacuestionariopanas
(
    idpregunta integer NOT NULL,
    pregunta character varying COLLATE pg_catalog."default" NOT NULL,
    CONSTRAINT preguntacuestionariopanas_pkey PRIMARY KEY (idpregunta)
)

TABLESPACE pg_default;


insert into preguntacuestionariopanas values(  1,'Interesado');
insert into preguntacuestionariopanas values(  2,'Disgustado');
insert into preguntacuestionariopanas values(  3,'Dispuesto');
insert into preguntacuestionariopanas values(  4,'Culpable');
insert into preguntacuestionariopanas values(  5,'Animado');
insert into preguntacuestionariopanas values(  6,'Temeroso');
insert into preguntacuestionariopanas values(  7,'Enérgico');
insert into preguntacuestionariopanas values(  8,'Enojado');
insert into preguntacuestionariopanas values(  9,'Entusiasmado');
insert into preguntacuestionariopanas values( 10,'Irritado');
insert into preguntacuestionariopanas values( 11,'Orgulloso');
insert into preguntacuestionariopanas values( 12,'Tenso');
insert into preguntacuestionariopanas values( 13,'Inspirado');
insert into preguntacuestionariopanas values( 14,'Avergonzado');
insert into preguntacuestionariopanas values( 15,'Decidido');
insert into preguntacuestionariopanas values( 16,'Nervioso');
insert into preguntacuestionariopanas values( 17,'Atento');
insert into preguntacuestionariopanas values( 18,'Intranquilo');
insert into preguntacuestionariopanas values( 19,'Activo');
insert into preguntacuestionariopanas values( 20,'Asustado');

CREATE TABLE IF NOT EXISTS public.respuestacuestionariopanas
(
    idrespuesta integer NOT NULL,
    respuesta character varying COLLATE pg_catalog."default" NOT NULL,
    puntaje integer NOT NULL,
    CONSTRAINT respuestacuestionariopanas_pkey PRIMARY KEY (idrespuesta)
)

TABLESPACE pg_default;

insert into respuestacuestionariopanas values(  1,'Nunca',1);
insert into respuestacuestionariopanas values(  2,'Casi nunca',2);
insert into respuestacuestionariopanas values(  3,'Ocasionalmente',3);
insert into respuestacuestionariopanas values(  4,'Casi siempre',4);
insert into respuestacuestionariopanas values(  5,'Siempre',5);


CREATE TABLE IF NOT EXISTS public.respuestapreguntacuestionariopanas
(
    idcuestionario bigint NOT NULL,
    idpregunta integer NOT NULL,
    idrespuesta integer NOT NULL,
    CONSTRAINT respuestapreguntacuestionariopanas_pkey PRIMARY KEY (idcuestionario, idpregunta),
    CONSTRAINT respuestapreguntacuestionariopanas_idcuestionario_fkey FOREIGN KEY (idcuestionario)
        REFERENCES public.cuestionariopanas (idcuestionario) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT respuestapreguntacuestionariopanas_idpregunta_fkey FOREIGN KEY (idpregunta)
        REFERENCES public.preguntacuestionariopanas (idpregunta) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION,
    CONSTRAINT respuestapreguntacuestionariopanas_idrespuesta_fkey FOREIGN KEY (idrespuesta)
        REFERENCES public.respuestacuestionariopanas (idrespuesta) MATCH SIMPLE
        ON UPDATE NO ACTION
        ON DELETE NO ACTION
)

TABLESPACE pg_default;