﻿var ESTADO = 1;
const TERMINADA = 3;
const CANTIDAD_PREGUNTAS = 20;
const ID_SEXO_FEMENINO = 1;
const ID_SEXO_MASCULINO = 1;
var idSexo = 0;

var confirmacionTerminacion = new bootstrap.Modal(document.getElementById('confirmacionTerminacion'), {
    keyboard: false
});

var terminacionExitosa = new bootstrap.Modal(document.getElementById('terminacionExitosa'), {
    keyboard: false
});

var errorTerminarAtencion = new bootstrap.Modal(document.getElementById('errorTerminarAtencion'), {
    keyboard: false
});

mensaje = function () { };
mensaje.warning = function (message) {
    $('#mensaje').html('<div class="alert alert-danger"><span>' + message + '</span></div>');
};
mensaje.success = function (message) {
    $('#mensaje').html('<div class="alert alert-success"><span>' + message + '</span></div>');
};
mensaje.removeWarning = function () {
    $('#mensaje').html('');
};


var editEscala = {};
var editMode = false;

$(document).ready(function () {
    if ($('#idEscala').val() && $('#idEscala').val() != "0") {
        editMode = true;
        $("#tipoDocumento").prop("disabled", true);
        $("#numeroDocumento").prop("disabled", true);
        buscar();
    }
    else {
        llenarControles();
        $(".terminar").hide();
    }
});

function buscarPersona(numeroDocumento) {
    idSexo = 0;
    if (numeroDocumento != "") {
        $.ajax({
            type: "GET",
            headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
            url: `${APIPath}/Persona/NumeroDocumento/${numeroDocumento}`,
            
            processData: false,
            contentType: false,
            
            success: function (persona) {
                $("#idPersona").val(persona.idPersona);
                $("#tipoDocumento").val(persona.idTipoDocumento);
                $("#primerNombre").val(persona.primerNombre);
                $("#segundoNombre").val(persona.segundoNombre);
                $("#primerApellido").val(persona.primerApellido);
                $("#segundoApellido").val(persona.segundoApellido);
                $("#sexo").val(persona.sexo);
                idSexo = persona.idSexo;
                $("#fechaNacimiento").val(moment.utc(persona.fechaNacimiento).format('YYYY-MM-DD'));
            },
            error: function (xhr, ajaxOptions, thrownError) {
                $("#idPersona").val("");
                $("#tipoDocumento").val("");
                $("#primerNombre").val("");
                $("#segundoNombre").val("");
                $("#primerApellido").val("");
                $("#segundoApellido").val("");
                $("#sexo").val("");
                $("#fechaNacimiento").val("");
            }
        });
    } else {
        $("#idPersona").val("");
        $("#tipoDocumento").val("");
        $("#primerNombre").val("");
        $("#segundoNombre").val("");
        $("#primerApellido").val("");
        $("#segundoApellido").val("");
        $("#sexo").val("");
        $("#fechaNacimiento").val("");
    }
}

async function buscar() {

    $.ajax({
        type: "GET",
        headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
        url: `${APIPath}/CuestionarioPanas/${$('#idEscala').val()}`,
        
        processData: false,
        contentType: false,
        
        success: function (result) {

            editEscala = result;
            llenarControles();
        }
    });
}

function mostrarMensajeConfirmacionTerminacion() {
    confirmacionTerminacion.show();
}

function terminarAtencion() {
    confirmacionTerminacion.hide();
    datosEscala = {
        id: obtenerNumero($('#idEscala').val())
    }

    $.ajax({
        type: "PUT",
        headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
        data: JSON.stringify(datosEscala),
        url: `${APIPath}/CuestionarioPanas/Terminar/${datosEscala.id}`,
        
        contentType: "application/json",
        dataType: "json",
        success: function () {
            $(".terminar").hide();
            $(".guardar").hide();
            mensaje.removeWarning();
            deshabilitarControles();
            terminacionExitosa.show();
        },
        error: function (request) {
            var error = "Error al terminar el test<br />"
            $('#mensajeErrorTerminacion').html(error);
            errorTerminarAtencion.show();
            mensaje.warning(error);
        }
    });
}

function guardarEscala() {
    if (validarDatos()) {
        mensaje.removeWarning();

        if (editMode)
            ESTADO = 2;

        var respuestasPregunta = [];
        for (var i = 1; i <= CANTIDAD_PREGUNTAS; i++) {
            if ($('#respuesta' + i).val() != "") {
                respuestasPregunta.push({
                    idPregunta: obtenerNumero($('#pregunta' + i).val()),
                    idRespuesta: obtenerNumero($('#respuesta' + i).val()),
                    puntaje: obtenerNumero($("#respuesta" + i + " option:selected").attr("puntaje"))
                });
            }
        }
        const respuestasPreguntaPositivas = respuestasPregunta.filter((pregunta) => pregunta.idPregunta % 2 != 0);
        const respuestasPreguntaNegativas = respuestasPregunta.filter((pregunta) => pregunta.idPregunta % 2 == 0);
        const totalPositivas = respuestasPreguntaPositivas.reduce((accumulator, respuestaPregunta) => {
            return accumulator + respuestaPregunta.puntaje;
        }, 0);
        const totalNegativas = respuestasPreguntaNegativas.reduce((accumulator, respuestaPregunta) => {
            return accumulator + respuestaPregunta.puntaje;
        }, 0);
        datosEscala = {
            id: obtenerNumero($('#idEscala').val()),
            IdEstado: ESTADO,
            idPersona: obtenerNumero($('#idPersona').val()),
            respuestasPregunta: respuestasPregunta
        }

        if (!editMode) {
            $.ajax({
                type: "POST",
                headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
                data: JSON.stringify(datosEscala),
                url: `${APIPath}/CuestionarioPanas`,
                contentType: "application/json",
                
                dataType: "json",
                success: function (result) {
                    editMode = true;
                    $('#idEscala').val(result.id);
                    $(".terminar").show();
                    establecerResultado(totalPositivas, totalNegativas);
                    mensaje.removeWarning();
                    var modal = new bootstrap.Modal(document.getElementById('confirmacionAlmacenamiento'), {
                        keyboard: false
                    });
                    modal.show();
                },
                error: function (request) {
                    var error = "Error al almacenar los datos<br />"
                    $('#errorRegistro').html(error);
                    var modal = new bootstrap.Modal(document.getElementById('errorAlmacenamiento'), {
                        keyboard: false
                    });
                    mensaje.warning(error);
                    modal.show();
                }
            });
        }
        else {
            $.ajax({
                type: "PUT",
                headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
                data: JSON.stringify(datosEscala),
                url: `${APIPath}/CuestionarioPanas/${datosEscala.id}`,
                
                contentType: "application/json",
                dataType: "json",
                success: function () {
                    mensaje.removeWarning();
                    establecerResultado(totalPositivas, totalNegativas);
                    var modal = new bootstrap.Modal(document.getElementById('confirmacionAlmacenamiento'), {
                        keyboard: false
                    });
                    modal.show();
                },
                error: function (request) {
                    var error = "Error al almacenar los datos<br />"
                    $('#errorRegistro').html(error);
                    var modal = new bootstrap.Modal(document.getElementById('errorAlmacenamiento'), {
                        keyboard: false
                    });
                    mensaje.warning(error);
                    modal.show();
                }
            });
        }
    }
}

function validarDatos() {

    if ($('#idPersona').val() == "") {
        mensaje.warning('La persona no es válida');
        return false;
    }

    return true;
}

async function llenarControles() {
    $.when($.ajax({
        type: "GET",
        headers: { Authorization: `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
        url: APIPath + "/Maestro/TiposDocumento"
    })).done(function (tiposDocumento) {

        $.each(tiposDocumento, function (index, item) {
            $('#tipoDocumento').append(`<option value='${item.id}' >${item.nombre}</option>`);
        });

        if (editMode) {
            $("#tipoDocumento").val(editEscala.persona.tipoDocumento.id);
            $("#numeroDocumento").val(editEscala.persona.numeroDocumento);
            $("#sexo").val(editEscala.persona.sexo.nombre);
            idSexo = editEscala.persona.sexo.id;
            $("#primerNombre").val(editEscala.persona.primerNombre);
            $("#segundoNombre").val(editEscala.persona.segundoNombre);
            $("#primerApellido").val(editEscala.persona.primerApellido);
            $("#segundoApellido").val(editEscala.persona.segundoApellido);
            $("#fechaNacimiento").val(moment.utc(editEscala.persona.fechaNacimiento).format('YYYY-MM-DD'));
            $('#idPersona').val(editEscala.persona.idPersona);

            for (var i = 0; i < editEscala.respuestasPregunta.length; i++) {
                $('#respuesta' + editEscala.respuestasPregunta[i].pregunta.id).val(editEscala.respuestasPregunta[i].respuesta.id);
            }

            const respuestasPreguntaPositivas = editEscala.respuestasPregunta.filter((respuesta) => respuesta.pregunta.id % 2 != 0);
            const respuestasPreguntaNegativas = editEscala.respuestasPregunta.filter((respuesta) => respuesta.pregunta.id % 2 == 0);
            const totalPositivas = respuestasPreguntaPositivas.reduce((accumulator, respuestaPregunta) => {
                return accumulator + respuestaPregunta.respuesta.puntaje;
            }, 0);
            const totalNegativas = respuestasPreguntaNegativas.reduce((accumulator, respuestaPregunta) => {
                return accumulator + respuestaPregunta.respuesta.puntaje;
            }, 0);

            establecerResultado(totalPositivas, totalNegativas);
            

            ESTADO = editEscala.estado.id;
            if (ESTADO == TERMINADA) {
                deshabilitarControles();
            }
        }
    });
}

function deshabilitarControles() {
    $(".terminar").hide();
    $(".guardar").hide();

    for (var i = 1; i <= CANTIDAD_PREGUNTAS; i++) {
        $('#respuesta' + i).prop("disabled", true);
    }
}

function establecerResultado(totalPositivas, totalNegativas) {
    if ((idSexo == ID_SEXO_FEMENINO && totalPositivas > 26) ||
         (idSexo == ID_SEXO_MASCULINO && totalPositivas > 25)) {
        $('#interpretacionPositiva').text("Alto afecto Positivo. Se caracteriza por alta energía, motivación, deseos de afiliación, concentración y agradable dedicación, sentimientos de dominio, logro y éxito; además de que es considerado como un factor protector de enfermedades y facilita un buen rendimiento");
        $('#recomendacionPositiva').html("1. Participar en actividades que promuevan la autoeficacia, como fijarse metas desafiantes, practicar deportes o involucrarse en proyectos colaborativos.<br><br>" +
            "2. Adquirir hábitos saludables como una buena alimentación, ejercicio regular y descanso adecuado para mantener altos niveles de energía.<br><br>" +
            "3. Celebrar los logros y éxitos personales y profesionales, y utilizar estos momentos para motivarse y fijarse nuevas metas.");
    }
    else if ((idSexo == ID_SEXO_FEMENINO && totalPositivas <= 26) ||
             (idSexo == ID_SEXO_MASCULINO && totalPositivas <= 25)) {
        $('#interpretacionPositiva').text("Bajo afecto positivo (se aplica depresión): Indicaría cansancio, letargo y fatiga. Los individuos en este grupo pueden experimentar falta de motivación y una visión negativa de sus logros.");
        $('#recomendacionPositiva').html("1. Iniciar rutinas de ejercicio físico moderado que puedan aumentar la energía y mejorar el estado de ánimo.<br><br>" +
	                                     "2. Considerar la posibilidad de consultar con un profesional de la salud mental para trabajar en la identificación y cambio de patrones de pensamiento negativos.<br><br>" +
	                                     "3. Involucrarse en actividades que previamente hayan sido placenteras o motivadoras, aunque inicialmente no se sienta motivación para ello.");
    }

    if ((idSexo == ID_SEXO_FEMENINO && totalNegativas > 32) ||
        (idSexo == ID_SEXO_MASCULINO && totalNegativas > 30)) {
        $('#interpretacionNegativa').text("Alta afectividad negativa (Se aplica ansiedad): Predominan sentimientos de temor, nerviosismo, ira y culpa, a menudo fruto de experiencias emocionales repetidas. Este estado puede estar asociado con altos niveles de ansiedad.");
        $('#recomendacionNegativa').html("1. Implementar prácticas como la meditación, el mindfulness o ejercicios de respiración profunda para reducir el nerviosismo y la ansiedad.<br><br>" +
            "2. Si la ansiedad es persistente o severa, es recomendable buscar apoyo profesional para explorar técnicas de manejo de la ansiedad, terapia o medicación si es necesario.<br><br>" +
            "3. Identificar y, si es posible, reducir los factores de estrés en la vida diaria. Establecer límites saludables y delegar tareas cuando sea necesario.");
    }
    else if ((idSexo == ID_SEXO_FEMENINO && totalNegativas <= 32) ||
        (idSexo == ID_SEXO_MASCULINO && totalNegativas <= 30)) {
        $('#interpretacionNegativa').text("Baja afectividad negativa: Supondría un estado de baja activación, calma y serenidad. Las personas en este grupo experimentan menos emociones negativas, lo que podría asociarse con un mayor bienestar.");
        $('#recomendacionNegativa').html("1. Continuar con prácticas que fomenten la calma, como el yoga, la meditación y el tiempo al aire libre.<br><br>" +
            "2. Fomentar relaciones interpersonales positivas y participar en actividades que refuercen el bienestar emocional.<br><br>" +
            "3. Seguir prestando atención a las señales del cuerpo y la mente, asegurándose de que la baja afectividad negativa no conduzca a la apatía o desmotivación.");
    }
}