﻿var tbEscalas;

$(document).ready(function () {

    tbEscalas = $('#escalas').DataTable({
        "language": {
            "decimal": ".",
            "thousands": ",",
            "processing": "<span><b>Buscando registros</b></span>",
            "lengthMenu": "Mostrar _MENU_ registros por página",
            "zeroRecords": "No se encontraron registros",
            "info": "Mostrando página _PAGE_ de _PAGES_",
            "infoEmpty": "No hay registros disponibles",
            "infoFiltered": "(Filtrado de _MAX_ registros totales)",
            "search": "Buscar:",
            "paginate": {
                "first": "Primero",
                "last": "Último",
                "next": "Próximo",
                "previous": "Anterior"
            }
        },
        "processing": true,
        "serverSide": true,
        "filter": true,
        "orderMulti": false,
        "destroy": true,
        "ordering": true,
        "paging": true,
        "ajax": {
            "url": `${APIPath}/CuestionarioPanas/Listado`,
            "type": "POST",
            "contentType": "application/json",
            "dataType": "json",
            "headers": { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
            "data": function (d) {
                return JSON.stringify(d);
            }
        },
        "columns": [
            {
                "data": "fecha", "name": "Fecha", "autoWidth": true, render: function (data, type, row) {
                    return `${moment.utc(row.fecha).format('YYYY/MM/DD HH:mm')}`
                }
            },
            { "data": "tipoDocumento", "name": "Tipo Documento", "autoWidth": true },
            { "data": "numeroDocumento", "name": "Número Documento", "autoWidth": true },
            { "data": "primerNombre", "name": "Primer Nombre", "autoWidth": true},
            { "data": "segundoNombre", "name": "Segundo Nombre", "autoWidth": true},
            { "data": "primerApellido", "name": "Primer Apellido", "autoWidth": true},
            { "data": "segundoApellido", "name": "Segundo Apellido", "autoWidth": true },
            { "data": "estado", "name": "Estado", "autoWidth": true },
            {
                "data": "id",
                render: function (data, type, row) {
                    return `<button class="btn btn-success" onclick="redirect('/cuestionarioPanas/crear?id=${data}')" data-action="actualizar"><i class="fa-solid fa-pencil"></i></button>`;
                }
            },
            {
                "data": "fechaInicial", "name": "Fecha Inicial", "autoWidth": true, "visible": false,
                render: function (data, type, row) {
                    return ``
                }
            },
            {
                "data": "fechaFinal", "name": "Fecha Final", "autoWidth": true, "visible": false,
                render: function (data, type, row) {
                    return ``
                }
            }
        ]

    });
    $("#escalas_filter").hide();
});

function consultar() {
    tbEscalas.columns(2).search($('#numeroDocumento').val().trim());
    tbEscalas.columns(3).search($('#primerNombre').val().trim());
    tbEscalas.columns(4).search($('#segundoNombre').val().trim());
    tbEscalas.columns(5).search($('#primerApellido').val().trim());
    tbEscalas.columns(6).search($('#segundoApellido').val().trim());
    tbEscalas.columns(9).search($('#fechaInicial').val());
    tbEscalas.columns(10).search($('#fechaFinal').val());
    tbEscalas.draw();
}