﻿
var editPersona = {};
var editMode = false;

var modalDireccion = new bootstrap.Modal(document.getElementById('md_direccion'), {
    keyboard: false
});

$(document).ready(function () {
    if ($('#idPersona').val() && $('#idPersona').val() != "0") {
        editMode = true;
        buscar();
    }
    else {
        llenarControles();
    }
    $('.form-select').select2({
        language: "es",
        theme: "bootstrap-5"
    });
});

async function buscar() {

    $.ajax({
        type: "GET",
        headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
        url: `${APIPath}/Persona/${$('#idPersona').val()}`,
        
        processData: false,
        contentType: false,
        
        success: function (result) {
            editPersona = result;
            llenarControles();
        }
    });
}

function guardar() {
    if (validarDatos()) {
        mensaje.removeWarning();
        datosPersona = {
            idPersona: obtenerNumero($('#idPersona').val()),
            idTipoDocumento: obtenerNumero($("#tipoDocumento").val()),
            idSexo: obtenerNumero($("#sexo").val()),
            numeroDocumento: $("#numeroDocumento").val(),
            primerApellido: $("#primerApellido").val(),
            segundoApellido: $("#segundoApellido").val(),
            primerNombre: $("#primerNombre").val(),
            segundoNombre: $("#segundoNombre").val(),

            fechaNacimiento: obtenerFecha($("#fechaNacimiento").val()),

            idCiudad: obtenerNumero($("#ciudad").val()),

            direccion: obtenerValor($("#direccion").val()),
            celular: $("#celular").val(),
            correoElectronico: obtenerValor($("#correoElectronico").val())
        }
        if (!editMode) {
            $.ajax({
                type: "POST",
                headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
                data: JSON.stringify(datosPersona),
                url: `${APIPath}/Persona`,
                contentType: "application/json",
                dataType: "json",
                success: function (result) {
                    editMode = true;
                    $('#idPersona').val(result.idPersona);
                    mensaje.removeWarning();
                    var modal = new bootstrap.Modal(document.getElementById('confirmacionAlmacenamiento'), {
                        keyboard: false
                    });
                    modal.show();
                },
                error: function (request) {
                    var error = "Error al almacenar los datos. ";
                    $('#errorRegistro').html(error);
                    var modal = new bootstrap.Modal(document.getElementById('errorAlmacenamiento'), {
                        keyboard: false
                    });
                    mensaje.warning(error);
                    modal.show();
                }
            });
        }
        else {
            $.ajax({
                type: "PUT",
                headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
                data: JSON.stringify(datosPersona),
                url: `${APIPath}/Persona/${datosPersona.idPersona}`,
                
                contentType: "application/json",
                dataType: "json",
                success: function () {
                    mensaje.removeWarning();
                    var modal = new bootstrap.Modal(document.getElementById('confirmacionAlmacenamiento'), {
                        keyboard: false
                    });
                    modal.show();
                },
                error: function (request) {
                    var error = "Error al almacenar los datos. ";
                    $('#errorRegistro').html(error);
                    var modal = new bootstrap.Modal(document.getElementById('errorAlmacenamiento'), {
                        keyboard: false
                    });
                    mensaje.warning(error);
                    modal.show();
                }
            });
        }
    }
}

function validarDatos() {

    if ($('#tipoDocumento').val() == "") {
        mensaje.warning('Seleccione el tipo de documento');
        return false;
    }
    else if ($('#numeroDocumento').val() == "") {
        mensaje.warning('Ingrese el número de documento');
        return false;
    }
    else if ($('#primerNombre').val() == "") {
        mensaje.warning('Ingrese el primer nombre');
        return false;
    }
    else if ($('#primerApellido').val() == "") {
        mensaje.warning('Ingrese el primer apellido');
        return false;
    }
    else if ($('#sexo').val() == "") {
        mensaje.warning('Seleccione el sexo');
        return false;
    }
    else if ($('#fechaNacimiento').val() == "") {
        mensaje.warning('Ingrese la fecha de nacimiento');
        return false;
    }

    return true;
}

function buscarDepartamentos(idDepartamento, idCiudad) {
        $.ajax({
            type: "GET",
            headers: { Authorization: `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
            url: APIPath + "/Maestro/Departamentos",
            success: function (departamentos) {
                $('#departamento').find('option').remove();
                $('#departamento').append('<option></option>');
                for (var i = 0; i < departamentos.length; i++) {
                    $('#departamento').append('<option value=' + departamentos[i].id + '>' + departamentos[i].nombre + '</option>');
                }
                if (idDepartamento > 0) {
                    $('#departamento').val(idDepartamento);
                    buscarCiudades(idDepartamento, idCiudad);
                }
            }
        });
}

function buscarCiudades(idDepartamento, idCiudad) {
    $.ajax({
        type: "GET",
        headers: { Authorization: `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
        url: APIPath + "/Maestro/Ciudades/" + idDepartamento,
        success: function (ciudades) {
            $('#ciudad').find('option').remove();
            $('#ciudad').append('<option></option>');
            for (var i = 0; i < ciudades.length; i++) {
                $('#ciudad').append('<option value=' + ciudades[i].id + '>' + ciudades[i].nombre + '</option>');
            }
            if (idCiudad > 0) {
                $('#ciudad').val(idCiudad);
            }
        }
    });
}

async function llenarControles() {
    $.when($.ajax({
            type: "GET",
            headers: { Authorization: `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
            url: APIPath + "/Maestro/TiposDocumento",
        }),
        $.ajax({
            type: "GET",
            headers: { Authorization: `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
            url: APIPath + "/Maestro/Sexos",
        }),
        $.ajax({
            type: "GET",
            headers: { Authorization: `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
            url: APIPath + "/Maestro/Departamentos",
        })).done(function (tiposDocumento, sexo, departamentos) {

            $.each(tiposDocumento[0], function (index, item) {
                $('#tipoDocumento').append(`<option value='${item.id}' >${item.nombre}</option>`);
            });

            $.each(sexo[0], function (index, item) {
                $('#sexo').append(`<option value='${item.id}'>${item.nombre}</option>`);
            });

            $.each(departamentos[0], function (index, item) {
                $('#departamento').append(`<option value='${item.id}'>${item.nombre}</option>`);
            });

            if (editMode) {
                $("#tipoDocumento").val(editPersona.idTipoDocumento);
                $("#numeroDocumento").val(editPersona.numeroDocumento);
                $("#primerNombre").val(editPersona.primerNombre);
                $("#segundoNombre").val(editPersona.segundoNombre);
                $("#primerApellido").val(editPersona.primerApellido);
                $("#segundoApellido").val(editPersona.segundoApellido);
                $("#sexo").val(editPersona.idSexo).trigger('change');
                $("#fechaNacimiento").val(moment.utc(editPersona.fechaNacimiento).format('YYYY-MM-DD'));
                $("#departamento").val(editPersona.idDepartamento).trigger('change');
                if (editPersona.idDepartamento)
                    buscarCiudades(editPersona.idDepartamento, editPersona.idCiudad);

                $("#direccion").val(editPersona.direccion);
                $("#celular").val(editPersona.celular);
                $("#correoElectronico").val(editPersona.correoElectronico);
            }
        });
}

mensaje = function () { };
mensaje.warning = function (message) {
    $('#mensaje').html('<div class="alert alert-danger"><span>' + message + '</span></div>');
};
mensaje.success = function (message) {
    $('#mensaje').html('<div class="alert alert-success"><span>' + message + '</span></div>');
};
mensaje.removeWarning = function () {
    $('#mensaje').html('');
};

function mostrarVentanaDireccion() {
    modalDireccion.show();
}

$("#letraVia").bind("input", function () {
    this.value = this.value.toUpperCase();
});
$("#letraViaGeneradora").bind("input", function () {
    this.value = this.value.toUpperCase();
});
$('#letraVia').keyup(function () {
    this.value = (this.value + '').replace(/[^A-Za-z]/g, '');
});
$('#letraViaGeneradora').keyup(function () {
    this.value = (this.value + '').replace(/[^A-Za-z]/g, '');
});

function agregarDireccion () {
    var direccion = $('#vistaPrevia').val();
    $('#direccion').val(direccion);
    modalDireccion.hide();
}

$('#numeroVia').keyup(function () {
    this.value = (this.value + '').replace(/[^0-9]/g, '');
});
$('#numeroViaGeneradora').keyup(function () {
    this.value = (this.value + '').replace(/[^0-9]/g, '');
});
$('#numeroPlaca').keyup(function () {
    this.value = (this.value + '').replace(/[^0-9]/g, '');
});
$('#tipoVia').change(function () {
    actualizarDireccion();
});
$('#numeroVia').change(function () {
    actualizarDireccion();
});
$('#letraVia').change(function () {
    actualizarDireccion();
});
$('#cuadrante').change(function () {
    actualizarDireccion();
});
$('#numeroViaGeneradora').change(function () {
    actualizarDireccion();
});
$('#letraViaGeneradora').change(function () {
    actualizarDireccion();
});
$('#cuadranteViaGeneradora').change(function () {
    actualizarDireccion();
});
$('#numeroPlaca').change(function () {
    actualizarDireccion();
});
$('#complemento').change(function () {
    actualizarDireccion();
});

function actualizarDireccion() {
    var direccion = "";
    if ($('#tipoVia').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#tipoVia').val().trim();
    }
    if ($('#numeroVia').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#numeroVia').val().trim();
    }
    if ($('#letraVia').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#letraVia').val().trim();
    }
    if ($('#cuadrante').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#cuadrante').val().trim();
    }
    if ($('#numeroViaGeneradora').val().trim() != '') {
        if (direccion != "") {
            direccion += ' # ';
        }
        direccion += $('#numeroViaGeneradora').val();
    }
    if ($('#letraViaGeneradora').val().trim() != '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#letraViaGeneradora').val().trim();
    }
    if ($('#numeroPlaca').val().trim() != '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#numeroPlaca').val().trim();
    }
    if ($('#cuadranteViaGeneradora').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#cuadranteViaGeneradora').val().trim();
    }
    if ($('#complemento').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#complemento').val().trim();
    }
    $("#vistaPrevia").val(direccion);
}