﻿var tbPersonas;
var idPersona = null;

$(document).ready(function () {

    tbPersonas = $('#persona').DataTable({
        "language": {
            "decimal": ".",
            "thousands": ",",
            "processing": "<span><b>Buscando registros</b></span>",
            "lengthMenu": "Mostrar _MENU_ registros por página",
            "zeroRecords": "No se encontraron registros",
            "info": "Mostrando página _PAGE_ de _PAGES_",
            "infoEmpty": "No hay registros disponibles",
            "infoFiltered": "(Filtrado de _MAX_ registros totales)",
            "search": "Buscar:",
            "paginate": {
                "first": "Primero",
                "last": "Último",
                "next": "Próximo",
                "previous": "Anterior"
            }
        },
        "processing": true,
        "serverSide": true,
        "filter": true,
        "orderMulti": false,
        "destroy": true,
        "ordering": true,
        "paging": true,
        "ajax": {
            "url": `${APIPath}/Persona/Personas`,
            "type": "POST",
            "contentType": "application/json",
            "dataType": "json",
            "headers": { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
            "data": function (d) {
                return JSON.stringify(d);
            }
        },
        "columns": [
            { "data": "tipoDocumento", "name": "Tipo Documento", "autoWidth": true },
            { "data": "numeroDocumento", "name": "Número Documento", "autoWidth": true },
            { "data": "primerNombre", "name": "Primer Nombre", "autoWidth": true },
            { "data": "segundoNombre", "name": "Segundo Nombre", "autoWidth": true },
            { "data": "primerApellido", "name": "Primer Apellido", "autoWidth": true },
            { "data": "segundoApellido", "name": "Segundo Apellido", "autoWidth": true },
            {
                "data": "idPersona",
                render: function (data, type, row) {
                    return `<button class="btn btn-success" onclick="redirect('/persona/crear?id=${data}')" data-action="actualizar"><i class="fa-solid fa-pencil"></i></button>`;
                }
            }
        ]

    });
    $("#persona_filter").hide();
});

function consultar() {

    tbPersonas.columns(1).search($('#numeroDocumento').val().trim());
    tbPersonas.columns(2).search($('#primerNombre').val().trim());
    tbPersonas.columns(3).search($('#segundoNombre').val().trim());
    tbPersonas.columns(4).search($('#primerApellido').val().trim());
    tbPersonas.columns(5).search($('#segundoApellido').val().trim());
    tbPersonas.draw();
}