﻿
var editUsuario = {};
var editMode = false;

$(document).ready(function () {
    if ($('#idUsuario').val() && $('#idUsuario').val() != "0") {
        editMode = true;
        buscar();
    }
    else {
        llenarControles();
    }
    $('.form-select').select2({
        language: "es",
        theme: "bootstrap-5"
    });
});

async function buscar() {

    $.ajax({
        type: "GET",
        headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
        url: `${APIPath}/Usuario/${$('#idUsuario').val()}`,

        processData: false,
        contentType: false,

        success: function (result) {
            editUsuario = result;
            llenarControles();
        }
    });
}

function buscarPersona(numeroDocumento) {
    if (numeroDocumento != "") {
        $.ajax({
            type: "GET",
            headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
            url: `${APIPath}/Persona/NumeroDocumento/${numeroDocumento}`,

            processData: false,
            contentType: false,

            success: function (persona) {
                $("#tipoDocumento").val(persona.idTipoDocumento).trigger('change');
                $("#primerNombre").val(persona.primerNombre);
                $("#segundoNombre").val(persona.segundoNombre);
                $("#primerApellido").val(persona.primerApellido);
                $("#segundoApellido").val(persona.segundoApellido);
                $("#sexo").val(persona.idSexo).trigger('change');
                $("#fechaNacimiento").val(moment(persona.fechaNacimiento).format('YYYY-MM-DD'));
                $("#departamento").val(persona.idDepartamento).trigger('change');

               if (persona.idDepartamento)
                    buscarDepartamentos(persona.idDepartamento, persona.idCiudad);

                $("#direccion").val(persona.direccion);
                $("#correoElectronico").val(persona.correoElectronico);
            },
            error: function (xhr, ajaxOptions, thrownError) {
                $("#tipoDocumento").val('').trigger('change');
                $("#primerNombre").val('');
                $("#segundoNombre").val('');
                $("#primerApellido").val('');
                $("#segundoApellido").val('');
                $("#sexo").val('').trigger('change');
                $("#fechaNacimiento").val('');

                $("#departamento").val('').trigger('change');
                $("#ciudad").val('').trigger('change');

                $("#direccion").val('');
                $("#correoElectronico").val('');
            }
        });
    } else {
        $("#tipoDocumento").val('').trigger('change');
        $("#primerNombre").val('');
        $("#segundoNombre").val('');
        $("#primerApellido").val('');
        $("#segundoApellido").val('');
        $("#sexo").val('').trigger('change');
        $("#fechaNacimiento").val('');

        $("#departamento").val('').trigger('change');
        $("#ciudad").val('').trigger('change');

        $("#direccion").val('');
        $("#correoElectronico").val('');
    }
}

async function guardar() {
    if (validarDatos()) {
        mensaje.removeWarning();

        var roles = [];
        $('[name="rol"]').each(function () {
            if ($(this).prop('checked') == true) {
                roles.push(obtenerNumero($(this).val()));
            }
        });

        datosUsuario = {
            idUsuario: obtenerNumero($('#idUsuario').val()),
            persona: {
                idTipoDocumento: obtenerNumero($("#tipoDocumento").val()),
                idSexo: obtenerNumero($("#sexo").val()),
                numeroDocumento: $("#numeroDocumento").val(),
                primerApellido: $("#primerApellido").val(),
                segundoApellido: $("#segundoApellido").val(),
                primerNombre: $("#primerNombre").val(),
                segundoNombre: $("#segundoNombre").val(),

                fechaNacimiento: obtenerFecha($("#fechaNacimiento").val()),

                idCiudad: obtenerNumero($("#ciudad").val()),
                direccion: obtenerValor($("#direccion").val()),
                correoElectronico: obtenerValor($("#correoElectronico").val())
            },
            activo: $("#activo").is(":checked"),
            nombreUsuario: obtenerValor($("#nombreUsuario").val()),
            clave: obtenerValor($("#clave").val()),
            roles: roles
        }
        if (!editMode) {
            $.ajax({
                type: "POST",
                headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
                data: JSON.stringify(datosUsuario),
                url: `${APIPath}/Usuario`,
                contentType: "application/json",
                dataType: "json",
                success: function (result) {
                    editMode = true;
                    $('#idUsuario').val(result.idUsuario);
                    mensaje.removeWarning();
                    var modal = new bootstrap.Modal(document.getElementById('confirmacionAlmacenamiento'), {
                        keyboard: false
                    });
                    modal.show();
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    var error = "Error al crear el usuario. ";
                    if (xhr && xhr.responseJSON && xhr.responseJSON.mensaje)
                        error += xhr.responseJSON.mensaje;
                    $('#errorRegistro').html(error);
                    var modal = new bootstrap.Modal(document.getElementById('errorAlmacenamiento'), {
                        keyboard: false
                    });
                    mensaje.warning(error);
                    modal.show();
                }
            });
        }
        else {
            $.ajax({
                type: "PUT",
                headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
                data: JSON.stringify(datosUsuario),
                url: `${APIPath}/Usuario/${datosUsuario.idUsuario}`,

                contentType: "application/json",
                dataType: "json",
                success: function () {
                    mensaje.removeWarning();
                    var modal = new bootstrap.Modal(document.getElementById('confirmacionAlmacenamiento'), {
                        keyboard: false
                    });
                    modal.show();
                },
                error: function (xhr, ajaxOptions, thrownError) {
                    var error = "Error al actualizar el usuario. ";
                    if (xhr && xhr.responseJSON && xhr.responseJSON.mensaje)
                        error += xhr.responseJSON.mensaje;
                    $('#errorRegistro').html(error);
                    var modal = new bootstrap.Modal(document.getElementById('errorAlmacenamiento'), {
                        keyboard: false
                    });
                    mensaje.warning(error);
                    modal.show();
                }
            });
        }
    }
}

function validarDatos() {
    if ($('#nombreUsuario').val() == "") {
        mensaje.warning('Ingrese el nombre de usuario');
        return false;
    }
    if (!editMode) {
        if ($('#clave').val() == "") {
            mensaje.warning('Ingrese la clave');
            return false;
        }
        else if ($('#clave').val() != $('#repetirClave').val()) {
            mensaje.warning('Las claves no conciden');
            return false;
        }
    }
    if ($('#tipoDocumento').val() == "") {
        mensaje.warning('Seleccione el tipo de documento');
        return false;
    }
    else if ($('#numeroDocumento').val() == "") {
        mensaje.warning('Ingrese el número de documento');
        return false;
    }
    else if ($('#primerNombre').val() == "") {
        mensaje.warning('Ingrese el primer nombre');
        return false;
    }
    else if ($('#primerApellido').val() == "") {
        mensaje.warning('Ingrese el primer apellido');
        return false;
    }
    else if ($('#sexo').val() == "") {
        mensaje.warning('Seleccione el sexo');
        return false;
    }
    else if ($('#fechaNacimiento').val() == "") {
        mensaje.warning('Ingrese la fecha de nacimiento');
        return false;
    }

    if (!$("#administrador").is(":checked") &&
        !$("#usuario").is(":checked")) {
        mensaje.warning('Debe seleccionar un rol');
        return false;
    }

    return true;
}

function buscarCiudades(idDepartamento, idCiudad) {
    $.ajax({
        type: "GET",
        headers: { Authorization: `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
        url: APIPath + "/Maestro/Ciudades/" + idDepartamento,
        success: function (ciudades) {
            $('#ciudad').find('option').remove();
            $('#ciudad').append('<option></option>');
            for (var i = 0; i < ciudades.length; i++) {
                $('#ciudad').append('<option value=' + ciudades[i].id + '>' + ciudades[i].nombre + '</option>');
            }
            if (idCiudad > 0) {
                $('#ciudad').val(idCiudad);
            }
        }
    });
}

async function llenarControles() {
    $.when($.ajax({
        type: "GET",
        headers: { Authorization: `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
        url: APIPath + "/Maestro/TiposDocumento",
    }),
        $.ajax({
            type: "GET",
            headers: { Authorization: `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
            url: APIPath + "/Maestro/Sexos",
        }),
        $.ajax({
            type: "GET",
            headers: { Authorization: `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
            url: APIPath + "/Maestro/Departamentos",
        })).done(function (tiposDocumento, sexo, departamentos) {

            $.each(tiposDocumento[0], function (index, item) {
                $('#tipoDocumento').append(`<option value='${item.id}' >${item.nombre}</option>`);
            });

            $.each(sexo[0], function (index, item) {
                $('#sexo').append(`<option value='${item.id}'>${item.nombre}</option>`);
            });

            $.each(departamentos[0], function (index, item) {
                $('#departamento').append(`<option value='${item.id}'>${item.nombre}</option>`);
            });

            if (editMode) {
                $("#tipoDocumento").val(editUsuario.persona.idTipoDocumento);
                $("#numeroDocumento").val(editUsuario.persona.numeroDocumento);
                $("#primerNombre").val(editUsuario.persona.primerNombre);
                $("#segundoNombre").val(editUsuario.persona.segundoNombre);
                $("#primerApellido").val(editUsuario.persona.primerApellido);
                $("#segundoApellido").val(editUsuario.persona.segundoApellido);
                $("#sexo").val(editUsuario.persona.idSexo);
                $("#fechaNacimiento").val(moment.utc(editUsuario.persona.fechaNacimiento).format('YYYY-MM-DD'));

                $("#departamento").val(editUsuario.persona.idDepartamento).trigger('change');
                if (editUsuario.persona.idDepartamento)
                    buscarCiudades(editUsuario.persona.idDepartamento, editUsuario.persona.idCiudad);

                $("#direccion").val(editUsuario.persona.direccion);
                $("#correoElectronico").val(editUsuario.persona.correoElectronico);
                $("#nombreUsuario").val(editUsuario.nombreUsuario);
                $("#activo").prop('checked', editUsuario.activo);
                if (editUsuario.roles) {
                    for (var i = 0; i < editUsuario.roles.length; i++) {
                        if (editUsuario.roles[i] == 1) {
                            $("#administrador").prop('checked', true);
                        }
                        else if (editUsuario.roles[i] == 2) {
                            $("#usuario").prop('checked', true);
                        }
                    }
                }
            }
        });
}

mensaje = function () { };
mensaje.warning = function (message) {
    $('#mensaje').html('<div class="alert alert-danger"><span>' + message + '</span></div>');
};
mensaje.success = function (message) {
    $('#mensaje').html('<div class="alert alert-success"><span>' + message + '</span></div>');
};
mensaje.removeWarning = function () {
    $('#mensaje').html('');
};

function mostrarFirma(input) {
    if (input.files && input.files[0]) {
        var reader = new FileReader();
        reader.onload = function (e) {
            $('#imagenFirma').css('visibility', 'visible');
            $('#imagenFirma').attr('src', e.target.result);
        }
        reader.readAsDataURL(input.files[0]);
    }
}

function mostrarVentanaDireccion() {
    modalDireccion.show();
}

$("#letraVia").bind("input", function () {
    this.value = this.value.toUpperCase();
});
$("#letraViaGeneradora").bind("input", function () {
    this.value = this.value.toUpperCase();
});
$('#letraVia').keyup(function () {
    this.value = (this.value + '').replace(/[^A-Za-z]/g, '');
});
$('#letraViaGeneradora').keyup(function () {
    this.value = (this.value + '').replace(/[^A-Za-z]/g, '');
});

function agregarDireccion() {
    var direccion = $('#vistaPrevia').val();
    $('#direccion').val(direccion);
    modalDireccion.hide();
}

$('#numeroVia').keyup(function () {
    this.value = (this.value + '').replace(/[^0-9]/g, '');
});
$('#numeroViaGeneradora').keyup(function () {
    this.value = (this.value + '').replace(/[^0-9]/g, '');
});
$('#numeroPlaca').keyup(function () {
    this.value = (this.value + '').replace(/[^0-9]/g, '');
});
$('#tipoVia').change(function () {
    actualizarDireccion();
});
$('#numeroVia').change(function () {
    actualizarDireccion();
});
$('#letraVia').change(function () {
    actualizarDireccion();
});
$('#cuadrante').change(function () {
    actualizarDireccion();
});
$('#numeroViaGeneradora').change(function () {
    actualizarDireccion();
});
$('#letraViaGeneradora').change(function () {
    actualizarDireccion();
});
$('#cuadranteViaGeneradora').change(function () {
    actualizarDireccion();
});
$('#numeroPlaca').change(function () {
    actualizarDireccion();
});
$('#complemento').change(function () {
    actualizarDireccion();
});

function actualizarDireccion() {
    var direccion = "";
    if ($('#tipoVia').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#tipoVia').val().trim();
    }
    if ($('#numeroVia').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#numeroVia').val().trim();
    }
    if ($('#letraVia').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#letraVia').val().trim();
    }
    if ($('#cuadrante').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#cuadrante').val().trim();
    }
    if ($('#numeroViaGeneradora').val().trim() != '') {
        if (direccion != "") {
            direccion += ' # ';
        }
        direccion += $('#numeroViaGeneradora').val();
    }
    if ($('#letraViaGeneradora').val().trim() != '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#letraViaGeneradora').val().trim();
    }
    if ($('#numeroPlaca').val().trim() != '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#numeroPlaca').val().trim();
    }
    if ($('#cuadranteViaGeneradora').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#cuadranteViaGeneradora').val().trim();
    }
    if ($('#complemento').val().trim() !== '') {
        if (direccion != "") {
            direccion += ' ';
        }
        direccion += $('#complemento').val().trim();
    }
    $("#vistaPrevia").val(direccion);
}