﻿var tbUsuarios;

var usuarioId = null;

var confirmacionEliminacion = new bootstrap.Modal(document.getElementById('confirmacionEliminacion'), {
    keyboard: false
});

var eliminacionExitosa = new bootstrap.Modal(document.getElementById('eliminacionExitosa'), {
    keyboard: false
});

var errorEliminarRegistro = new bootstrap.Modal(document.getElementById('errorEliminarRegistro'), {
    keyboard: false
});



$(document).ready(function () {
    tbUsuarios = $('#usuario').DataTable({        
        "language": {
            "decimal": ".",
            "thousands": ",",
            "processing": "<span><b>Buscando registros</b></span>",
            "lengthMenu": "Mostrar _MENU_ registros por página",
            "zeroRecords": "No se encontraron registros",
            "info": "Mostrando página _PAGE_ de _PAGES_",
            "infoEmpty": "No hay registros disponibles",
            "infoFiltered": "(Filtrado de _MAX_ registros totales)",
            "search": "Buscar:",
            "paginate": {
                "first": "Primero",
                "last": "Último",
                "next": "Próximo",
                "previous": "Anterior"
            }
        },
        "processing": true,
        "serverSide": true,
        "filter": true,
        "orderMulti": false,
        "destroy": true,
        "ordering": true,
        "paging": true,
        "ajax": {
            "url": `${APIPath}/Usuario/ObtenerUsuarios`,
            "type": "POST",
            "contentType": "application/json",
            "dataType": "json",
            "headers": { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
            "data": function (d) {
                return JSON.stringify(d);
            }
        },
        "columns": [
            { "data": "nombreUsuario", "name": "Usuario", "autoWidth": true },
            { "data": "tipoDocumento", "name": "Tipo Documento", "autoWidth": true },
            { "data": "numeroDocumento", "name": "Número Documento", "autoWidth": true },
            { "data": "primerNombre", "name": "Primer Nombre", "autoWidth": true },
            { "data": "segundoNombre", "name": "Segundo Nombre", "autoWidth": true },
            { "data": "primerApellido", "name": "Primer Apellido", "autoWidth": true },
            { "data": "segundoApellido", "name": "Segundo Apellido", "autoWidth": true },
            {
                "data": "idUsuario",
                render: function (data, type, row) {
                    return `<button class="btn btn-success" onclick="redirect('/seguridad/usuario/crear?id=${data}')"><i class="fa-solid fa-pencil"></i></button>`;
                }
            },
            {
                "data": "idUsuario",
                render: function (data, type, row) {
                    return `<button class="btn btn-danger" onclick="mostrarMensajeConfirmacionEliminacion(${data})"><i class="fa-solid fa-trash-can"></i></button>`
                }
            }
        ]

    });
    consultar();
    llenarControles();
    $("#usuario_filter").hide();
});



function llenarControles() {

    $.when($.ajax({
        type: "GET",
        headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
        url: APIPath + "/TipoPersona/GetMaster"
    }),
    ).done(function (tiposPersona) {

        $.each(tiposPersona, function (index, item) {
            $('#tipoPersona').append(`<option value='${item.id}' >${item.nombre}</option>`);
        });

    });
}
function consultar() {
    
    tbUsuarios.columns(0).search($('#nombreUsuario').val().trim());
    tbUsuarios.columns(1).search($('#numeroDocumento').val().trim());
    tbUsuarios.columns(2).search($('#primerNombre').val().trim());
    tbUsuarios.columns(3).search($('#segundoNombre').val().trim());
    tbUsuarios.columns(4).search($('#primerApellido').val().trim());
    tbUsuarios.columns(5).search($('#segundoApellido').val().trim());
    
    tbUsuarios.draw();
}

function mostrarMensajeConfirmacionEliminacion(id) {
    usuarioId = id;
    confirmacionEliminacion.show();
}

function eliminarUsuario() {
    confirmacionEliminacion.hide();
    $.ajax({
        type: "DELETE",
        headers: { "Authorization": `Bearer ${JSON.parse(localStorage.getItem(TOKEN))}` },
        url: APIPath + "/usuario/" + usuarioId,
        success: function () {
            consultar();
            eliminacionExitosa.show();
        },
        error: function (request) {
            var error = "Error al eliminar la usuario<br />"
            var errores = "";
            if (request.responseJSON && request.responseJSON.errors) {
                var errores = "<ul>";
                request.responseJSON.errors.forEach(element => element.messages.forEach(e => errores += "<li>" + e));
                errores += "</u>";
            }

            $('#mensajeErrorEliminacion').html(error + errores);
            errorEliminarCompetencia.show();
        }
    });
}